/*
 * Created by JFormDesigner on Thu Jul 25 14:05:38 EDT 2024
 */

package tech.nevets.packetmirror;

import java.awt.event.*;
import java.io.IOException;
import javax.swing.*;
import net.miginfocom.swing.*;

/**
 * @author steven
 */
public class HomePanel extends JPanel {
    private boolean send = true;
    private PServer server;

    public HomePanel() {
        initComponents();
    }

    private void sendBtn(ActionEvent e) {
        startBtn.setText("Send");
        send = true;
        hostLabel.setVisible(true);
        hostField.setVisible(true);
        dataLabel.setVisible(true);
        dataArea.setVisible(true);
        dataScroll.setVisible(true);
        responseLabel.setText("Response");
        stopBtn.setVisible(false);
    }

    private void receiveBtn(ActionEvent e) {
        startBtn.setText("Start");
        send = false;
        hostLabel.setVisible(false);
        hostField.setVisible(false);
        dataLabel.setVisible(false);
        dataArea.setVisible(false);
        dataScroll.setVisible(false);
        responseLabel.setText("Data");
        stopBtn.setVisible(true);
    }

    private void startBtn(ActionEvent e) {
        if (send) {
            switch (((String) protocol.getSelectedItem()).toLowerCase()) {
                case "tcp" -> {
                    try {
                        statusLabel.setText("Sending...");
                        responseArea.setText(TCPClient.sendPacket(hostField.getText(), Integer.parseInt(portField.getText()), dataArea.getText()));
                        statusLabel.setText("Sent");
                    } catch (IOException ex) {
                        statusLabel.setText("Error 1");
                        errorLabel.setText(ex.getMessage());
                        ex.printStackTrace();
                    }
                }
                case "udp" -> {
                    try {
                        statusLabel.setText("Sending...");
                        responseArea.setText(UDPClient.sendDatagram(hostField.getText(), Integer.parseInt(portField.getText()), dataArea.getText()));
                        statusLabel.setText("Sent");
                    } catch (IOException ex) {
                        statusLabel.setText("Error 2");
                        errorLabel.setText(ex.getMessage());
                        ex.printStackTrace();
                    }
                }
            }
        } else {
            startBtn.setEnabled(false);
            stopBtn.setEnabled(true);
            switch (((String) protocol.getSelectedItem()).toLowerCase()) {
                case "tcp" -> {
                    try {
                        statusLabel.setText("Running...");
                        server = new TCPServer(Integer.parseInt(portField.getText()));
                        server.start(responseArea, statusLabel, errorLabel);
                    } catch (IOException ex) {
                        statusLabel.setText("Error 3");
                        errorLabel.setText(ex.getMessage());
                        ex.printStackTrace();
                    }
                }
                case "udp" -> {
                    try {
                        statusLabel.setText("Running...");
                        server = new UDPServer(Integer.parseInt(portField.getText()));
                        server.start(responseArea, statusLabel, errorLabel);
                    } catch (IOException ex) {
                        statusLabel.setText("Error 4");
                        errorLabel.setText(ex.getMessage());
                        ex.printStackTrace();
                    }
                }
            }
        }
    }

    private void resetBtn(ActionEvent e) {
        hostField.setText("");
        portField.setText("");
        dataArea.setText("");
        statusLabel.setText("");
        responseArea.setText("");
        errorLabel.setText("");
    }

    private void stopBtn(ActionEvent e) {
        server.stop();
        statusLabel.setText("Server Stopped");
        startBtn.setEnabled(true);
        stopBtn.setEnabled(false);
    }

    private void initComponents() {
        // JFormDesigner - Component initialization - DO NOT MODIFY  //GEN-BEGIN:initComponents  @formatter:off
        protoLabel = new JLabel();
        protocol = new JComboBox();
        typeLabel = new JLabel();
        sendBtn = new JRadioButton();
        receiveBtn = new JRadioButton();
        ButtonGroup sndRecBtnGroup = new ButtonGroup();
        dataLabel = new JLabel();
        hostLabel = new JLabel();
        hostField = new JTextField();
        dataScroll = new JScrollPane();
        dataArea = new JTextArea();
        portLabel = new JLabel();
        portField = new JTextField();
        responseLabel = new JLabel();
        responseScroll = new JScrollPane();
        responseArea = new JTextArea();
        statusLabel = new JLabel();
        startBtn = new JButton();
        stopBtn = new JButton();
        resetBtn = new JButton();
        errorLabel = new JLabel();

        //======== this ========
        setLayout(new MigLayout(
            "hidemode 3",
            // columns
            "[shrink 0,fill]" +
            "[fill]" +
            "[100,shrink 0,fill]" +
            "[grow,shrink 0,fill]" +
            "[fill]" +
            "[fill]" +
            "[fill]" +
            "[shrink 0,fill]",
            // rows
            "[]" +
            "[]" +
            "[]" +
            "[shrink 0]" +
            "[shrink 0]" +
            "[bottom]" +
            "[grow]" +
            "[]" +
            "[]" +
            "[]"));

        //---- protoLabel ----
        protoLabel.setText("Protocol");
        add(protoLabel, "cell 1 1");

        //---- protocol ----
        protocol.setModel(new DefaultComboBoxModel<>(new String[]{"TCP", "UDP"}));
        add(protocol, "cell 2 1,alignx leading,growx 0");

        //---- typeLabel ----
        typeLabel.setText("Client Type");
        add(typeLabel, "cell 4 1");

        //---- sendBtn ----
        sendBtn.setText("Send");
        sendBtn.setSelected(true);
        sendBtn.addActionListener(e -> sendBtn(e));
        add(sendBtn, "cell 5 1");

        //---- receiveBtn ----
        receiveBtn.setText("Receive");
        receiveBtn.addActionListener(e -> receiveBtn(e));
        sndRecBtnGroup.add(sendBtn);
        sndRecBtnGroup.add(receiveBtn);
        add(receiveBtn, "cell 6 1");

        //---- dataLabel ----
        dataLabel.setText("Data");
        add(dataLabel, "cell 5 2");

        //---- hostLabel ----
        hostLabel.setText("Host");
        add(hostLabel, "cell 1 3");
        add(hostField, "cell 2 3");

        //======== dataScroll ========
        {
            dataScroll.setViewportView(dataArea);
        }
        add(dataScroll, "cell 4 3 3 2,grow");

        //---- portLabel ----
        portLabel.setText("Port");
        add(portLabel, "cell 1 4");
        add(portField, "cell 2 4");

        //---- responseLabel ----
        responseLabel.setText("Response");
        add(responseLabel, "cell 3 5");

        //======== responseScroll ========
        {

            //---- responseArea ----
            responseArea.setEditable(false);
            responseScroll.setViewportView(responseArea);
        }
        add(responseScroll, "cell 2 6 3 2,grow");
        add(statusLabel, "cell 2 8");

        //---- startBtn ----
        startBtn.setText("Send");
        startBtn.addActionListener(e -> startBtn(e));
        add(startBtn, "cell 3 8,alignx center,growx 0");

        //---- stopBtn ----
        stopBtn.setText("Stop");
        stopBtn.setEnabled(false);
        stopBtn.setVisible(false);
        stopBtn.addActionListener(e -> stopBtn(e));
        add(stopBtn, "cell 4 8");

        //---- resetBtn ----
        resetBtn.setText("Clear");
        resetBtn.addActionListener(e -> resetBtn(e));
        add(resetBtn, "cell 6 8");
        add(errorLabel, "cell 1 9 6 1");
        // JFormDesigner - End of component initialization  //GEN-END:initComponents  @formatter:on
    }

    // JFormDesigner - Variables declaration - DO NOT MODIFY  //GEN-BEGIN:variables  @formatter:off
    private JLabel protoLabel;
    private JComboBox protocol;
    private JLabel typeLabel;
    private JRadioButton sendBtn;
    private JRadioButton receiveBtn;
    private JLabel dataLabel;
    private JLabel hostLabel;
    private JTextField hostField;
    private JScrollPane dataScroll;
    private JTextArea dataArea;
    private JLabel portLabel;
    private JTextField portField;
    private JLabel responseLabel;
    private JScrollPane responseScroll;
    private JTextArea responseArea;
    private JLabel statusLabel;
    private JButton startBtn;
    private JButton stopBtn;
    private JButton resetBtn;
    private JLabel errorLabel;
    // JFormDesigner - End of variables declaration  //GEN-END:variables  @formatter:on
}
