package tech.nevets.packetmirror;

import javax.swing.*;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.ServerSocket;
import java.net.Socket;

public class TCPServer implements PServer {
    private ServerSocket ss;
    private boolean running = true;

    public TCPServer(int port) throws IOException {
        ss = new ServerSocket(port);
    }

    @Override
    public void start(JTextArea textArea, JLabel statusLabel, JLabel errorLabel) {
        new Thread(() -> {
            while (running) {
                try {
                    Socket s = ss.accept();
                    InputStream is = s.getInputStream();
                    OutputStream os = s.getOutputStream();

                    byte[] buf = new byte[1024];
                    int i = 0;
                    for (byte b = (byte) is.read(); b != 0xf; b = (byte) is.read()) {
                        buf[i] = b;
                        i++;
                    }

                    textArea.setText(new String(buf));
                    os.write(buf, 0, i);
                    os.write(0xf);
                    os.flush();
                } catch (IOException e) {
                    switch (e.getMessage().toLowerCase()) {
                        case "socket closed" -> {
                            statusLabel.setText("Server stopped");
                            return;
                        }
                        case "connection reset" -> {
                            statusLabel.setText("Client disconnected");
                            return;
                        }
                    }
                    statusLabel.setText("Error tser");
                    errorLabel.setText(e.getMessage());
                    e.printStackTrace();
                }
            }

        }).start();
    }

    @Override
    public void stop() {
        running = false;
        try {
            ss.close();
        } catch (IOException e) {
            System.out.println("error stop tcpserver");
            e.printStackTrace();
        }
    }

}
